// 
//  Copyright (C) 2001, 2000, 1999 David Essex
// 
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2, or (at your option)
//  any later version.
//  
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with this software; see the file COPYING.  If not, write to
//  the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
//  Boston, MA 02111-1307 USA
// 


#ifndef _TCPPHELP_H
#define _TCPPHELP_H

//#define TCOBPP_LANGUAGE_en       1

#ifdef TCOBPP_LANGUAGE_en

/* Usage list */
/* Usage: %s <options> <input_file> [-o <output_file>]\n" */
static char usage_list0[] = { "<options> <input_file> [-o <output_file>]\n" };
static char usage_list1[] = { "where <options> are:\n\
      -h                Help (display this listing)\n\
      -V	        Display version and exit\n\
      -v	        Verbose mode\n\
      -d	        Include debug lines\n\
      -g	        Turn on debuging mode\n\
      -t <num>          Expand tabs to <num> space(s)\n\
      -o <output_file>  Output file name (default: standard output)\n\
      -p <listing_file> Listing file name \n\
      -x <input_file>   Input source is in free form format\n\
      -f <input_file>   Input source is in standard fixed column format\n\
      -I <copy_dir>     Copybooks search directories \n\
" };
#endif

#ifdef TCOBPP_LANGUAGE_fr

static char usage_list0[] = { "<options> <fichier en entre> [-o <fichier en sortie>]\n" };
static char usage_list1[] = { "options:\n\
      -h                                          Affiche l'aide\n\
      -V	                                  Affiche la version\n\
      -v	                                  Mode verbeux\n\
      -d	                                  Inclut les lignes de dbogage\n\
      -g	                                  Positionne le mode de dbogage\n\
      -t <nombre>                                 Transforme les tabulations en <nombre> d'espace(s)\n\
      -o <fichier_en_sortie>                      Nom du fichier en sortie (dfaut: sortie standard)\n\
      -p <fichier_liste>                          Nom du fichier de liste\n\
      -x <fichier_en_entre'e>                     Le fichier en entre est en format libre (X/Open)\n\
      -f <fichier_en_entre'e>                     Le fichier en entre est en format standard (colonnage fixe)\n\
      -I <rpertoires_des_fichiers_d'inclusion>  Rpertoires de recherche des fichiers d'inclusion\n\
" };
#endif

#ifdef TCOBPP_LANGUAGE_it

static char usage_list0[] = { "<opzioni> <nome_file_da_pre-processare> [-o <nome_file_di_destinazione>]\n" };
static char usage_list1[] = { "opzioni:\n\
      -h                Visualizza l'aiuto\n\
      -V	        Versione\n\
      -v	        Modalita` prolissa\n\
      -d	        Include le linee di debug\n\
      -g	        Attiva la modalita` di debuging\n\
      -t <num>          Converte i 'tabs' in <num> spazi\n\
      -o <output_file>  Nome file da generare (default: standard output)\n\
      -p <listing_file> Nome file del listato\n\
      -x <input_file>   Il sorgente in ingresso e` formattato in modalita` libera (free form)\n\
      -f <input_file>   Il sorgente in ingresso e` formattato in modalita` Standard\n\
      -I <copy_dir>     Cartella di ricerca dei files 'Copybooks'\n\
" };
#endif

#ifdef TCOBPP_LANGUAGE_pt_BR

static char usage_list0[] = { "<opcoes> <arquivo-de-entrada> [-o <arquivo-de-saida>]\n" };
static char usage_list1[] = { "opcoes:\n\
      -h                        Mostra ajuda\n\
      -V	                Mostra versao\n\
      -v	                Modo verboso\n\
      -d	                Inclui linhas de debug\n\
      -g	                Muda para modo de debug\n\
      -t <num>                  Expande tabs para <num> espaco(s)\n\
      -o <arquivo_saida>        Nome do arquivo de saida (padrao: saida padrao)\n\
      -p <arquivo_listado>      Nome do arquivo listado \n\
      -x <arquivo_entrada>      O arquivo de entrada esta no formato livre\n\
      -f <arquivo_entrada>      Arquivo de entrada esta em formato de coluna fixa padrao\n\
      -I <diretorio_copybooks>  Diretorios de procura de copybooks\n\
" };
#endif

#ifdef TCOBPP_LANGUAGE_es

/* Usage list */
/* Usage: %s <options> <input_file> [-o <output_file>]\n" */
static char usage_list0[] = { "<opciones> <fichero_entrada> [-o <fich_salida]\n" };
static char usage_list1[] = { "donde <opciones> son:\n\
      -h                Ayuda (muestra este listado)\n\
      -V                Muestra la versin y termina\n\
      -v                Modo detallado\n\
      -d                Incluye lineas de debug\n\
      -g                Activa el modo debug\n\
      -t <num>          Expandir tabulados a <num> espacios\n\
      -o <fich_salida>  Nombre del fichero salida (defecto: salida estndar)\n\
      -p <fich_listado> Nombre del fichero listado\n\
      -x <fich_entrada> El fuente de entrada est en formato libre\n\
      -f <fich_entrada> El fuente est en formato estndar de cols fijas\n\
      -I <dir_copy>     Directorios de bsqueda para Copybooks\n\
" };
#endif

#endif
