.\"
.\"  Created by Ferran Pegueroles using help2man and modified by hand.
.\"  Modified and updated by David Essex.
.\"  Tranlated to spanish language by Juan J. Martnez.
.\" 
.TH HTCOBOL 1 "22 de Enero de 2002"
.UC 6
.SH NOMBRE
htcobol \- compilador de COBOL 85
.SH SUMARIO
.B htcobol 
[
.I opciones
] 
.I nombrefichero
.SH "DESCRIPCIN"
Un compilador para el
.B CO\fRmmon
.B B\fRusiness 
.B O\fRriented 
.B L\fRanguage, 
.B COBOL\fR.
.PP
.I Htcobol
lee un fuente de COBOL desde el fichero
.I nombrefichero
y dependiendo de la opcin, preprocesar, compilar, ensamblar y enlazar
para generar un binario ejecutable.
.PP
El compilador genera ensamblador GNU para la plataforma IA32 (i386).
Con la ayuda de un conjunto de herramientas \fBGCC\fR, este cdigo
intermedio puede ser compilado y enlazado generando un binario ejecutable.
.PP
Un binario ejecutable puede se creado tanto directamente por el compilador,
como generando cdigo ensamblador intermedio y usando un
.I Makefile
para los pasos de ensamblado y enlazado.
.PP
El compilador reconoce varias opciones de linea de comando como se describe
a continuacin.
.PP
Puede obtener un mensaje de ayuda invocando htcobol con la opcin \fB\-h\fR.
.PP
.SH "FICHEROS DE INICIALIZACIN"
Muchas opciones del compilador pueden ser indicadas
usando el archivo de recursos y/o opciones de la linea de comando.
.PP
El nombre por defecto para el fichero de opciones del compilador es
.I htcobolrc\fR.
.PP
El orden de precedencia de cualquier opcin del compilador es como sigue:
.TP
1.
Opciones de la linea de comandos, de haberlas.
.TP
2.
Variables de entorno, de haberlas.
.TP
3.
Las opciones del fichero \fIhtcobolrc\fR, de haberlas.
.TP
4.
Opciones de compilacin por defecto, de haberlas. 
.SH "OPCIONES"
.B Opciones especficas del compilador:
.TP
\fB\-h\fR
Muestra ayuda.
.TP 
\fB\-a\fR
Crea una librera esttica; Preprocesar, compilar, ensamblar y archivar.
.TP 
\fB\-B\fR
Especificar el modo para enlazado (static o dynamic).
.TP
\fB\-c\fR
Preprocesa, compila y ensambla, pero no enlaza.
.TP
\fB\-E\fR
Muestra solo la salida del preprocesador a salida estandard; no compila, ensambla o enlaza.
.TP
\fB\-g\fR
Generar salida de compilador para debug.
.TP
\fB\-l\fR <nombre>
Aade la librera al enlazado.
.TP 
\fB\-L\fR <directorio>
Aade el directorio al camino de bsqueda de libreras.
.TP 
\fB\-m\fR
Crea una librera compartida; Preprocesa, compila, ensambla y enlaza.
.TP 
\fB\-n\fR
No ejecuta ningn comando; solo los muestra.
.TP 
\fB\-o\fR <fichero> 
Especifica el nombre del fichero de salida.
.TP 
\fB\-S\fR
Solo preprocesar y compilar (genera cdigo ensablador); no ensambla o enlaza.
.TP
\fB\-t\fR
No elimina los ficheros intermedios generados durante la compilacin (ensamblador, fichero COBOL pre-procesado).
.TP
\fB\-v\fR
Genera salida del compilador detallada.
.TP
\fB\-V\fR
Muestra la versin del compilador y termina.
.TP
\fB\-Wl,<opciones> \fR 
Pasa <opciones>, separadas por comas, al enlazador.
.TP
\fB\-x\fR
Crea un ejecutable; preprocesa, compila, ensambla y enlaza.
.TP 
\fB\-z\fR
Genera la salida del compilador muy detallada.
.PP
.B Opciones especficas de COBOL:
.TP 
\fB\-C\fR
Hace todas las llamadas de COBOL dinmicas.
.TP 
\fB\-D\fR
Incluye lineas del fuente para debug.
.TP 
\fB\-F\fR
El fuente de entrada est en formato estndar de columnas fijas.
.TP
\fB\-I\fR <camino> 
Define camnos de bsqueda para inclusin (copybooks) (por defecto \-I./)
El camino puede ser tanto un directorio como una lista de directorios
separados por un `:' (`;' en la plataforma Win32).
.TP 
\fB\-P\fR
Genera un fichero listado de la salida.
.TP 
\fB\-T\fR <num>
Expande los tabuladores a un nmero de espacios (por defecto T=8)
.TP 
\fB\-X\fR
El fichero de entrada est en formato libre X/Open (formato por defecto).
.PP 
.SH "FICHEROS"
.TP
.I htcobolrc\fR fichero de recurso.
.SH ENTORNO
.TP
.B TCOB_OPTIONS
.TP
Nombre del fichero de recurso.
.TP
El nombre por defecto es \fIhtcobolrc\fR.
.TP
.B TCOB_OPTIONS_PATH
Camino al directorio del fichero de recursos.
.TP
.B TCOB_PP_PATH
Camino al directorio del preprocesador.
.TP
.B TCOB_LD_LIBRARY_PATH
Camino de bsqueda para las libreras cargadas dinmicamente.
.TP
.B  TEMP
Camino al directorio de ficheros temporales.
.SH "CONSULTAR TAMBIN"
GCC(1), as(1), ld(1), make(1).
