.\"
.\"  Created by Ferran Pegueroles using help2man and modified by hand.
.\"  Modified and updated by David Essex.
.\" 
.TH HTCOBOL 1 "11 aot 2002"
.UC 6
.SH NOM
htcobol \- Compilateur COBOL 85
.SH SYNTAXE
.B htcobol 
[
.I options
] 
.I fichier
.SH "DESCRIPTION"
Un compilateur pour le
\fBCO\fRmmon
\fBB\fRusiness 
\fBO\fRriented 
\fBL\fRanguage, 
\fBCOBOL\fR.
.PP 
.I Htcobol
lit un source COBOL depuis le
.I fichier
et, dpendant de l'option, prprocdera, compilera, assemblera et liera (fera une
dition de liens) pour gnrer un excutable binaire.
.PP
Le compilateur gnre de l'assembleur GNU pour la plateforme IA32 (i386).
A l'aide du jeu d'outils \fBGCC\fR, ce code intermdiaire peut ensuite tre
assembl et li pour crer un excutable binaire.
.PP
Un excutable binaire peut tre cr soit directement par le compilateur,
soit en gnrant du code assembleur intermdiaire et en utilisant un
.I Makefile
pour les tapes d'assemblage et d'dition de liens.
.PP
Le compilateur reconnait plusieurs options de ligne de commande, dcrits
ci-dessous.
.PP
Vous pouvez obtenir un message d'aide en invoquant htcobol avec l'option
.B \-h.
.PP
.SH "FICHIERS D'INITIALISATION"
Beaucoup d'options du compilateur peuvent tre tablies en utilisant
le fichier de ressources et/ou les options de la ligne de commande.
.PP
Le nom du fichier de ressources par dfaut est
.I htcobolrc\fR.
.PP
La prsance des options de compilation est la suivante:
.TP
1.
Options de la ligne de commande, si disponibles.
.TP
2.
Variables d'environnement, si disponibles.
.TP
3.
Les options du fichier de ressources, si disponibles.
.TP
4.
Les valeurs des options de ressource par dfaut  la compilation, si
disponibles.
.SH "OPTIONS"
.B Options spcifiques au compilateur:
.TP
\fB\-h\fR 
Affiche l'aide.
.TP 
\fB\-a\fR
Cre une librairie statique; prprocde, compile, assemble et archive
.TP 
\fB\-B\fR
Spcifie le mode de liens (statique/dynamique)
.TP 
\fB\-c\fR
Compile un module objet li statiquement
.TP 
\fB\-E\fR
Sort seulement le rsultat du prtraitement sur la sortie standard;
ne compile pas, ni n'assemble ou lie
.TP 
\fB\-g\fR
Gnre les informations de dbogage
.TP 
\fB\-l\fR <nom> 
Ajoute le nom de la librairie  l'tape de liens
.TP 
\fB\-L\fR <dir> 
Ajoute le rpertoire  la liste de recherche des librairies
.TP 
\fB\-m\fR 
Cre une librairie partage; prprocde, compile, assemble et lie
.TP 
\fB\-n\fR
N'excute pas les commandes; les montre seulement
.TP 
\fB\-o\fR <fichier> 
Spcifie le fichier de sortie
.TP 
\fB\-S\fR
Prprocde, compile seulement (gnre le code assembleur); n'assemble pas, ni ne
lie
.TP 
\fB\-t\fR
Conserve les fichiers intermdiaires de la compilation (assembleur, COBOL
prprocess).
lie
.TP 
\fB\-v\fR
Demande une sortie verbeuse du compilateur
.TP 
\fB\-V\fR
Affiche les informations de version du compilateur et sort
.TP 
\fB\-Wl,<options> \fR 
Passe une liste d'<options> spare par virgule  l'diteur de liens
.TP 
\fB\-x\fR
Compile un module excutable
.TP 
\fB\-z\fR
Demande une sortie trs verbeuse du compilateur
.PP 
.B Options spcifiques  COBOL:
.TP 
\fB\-C\fR
Rends tous les appels COBOL dynamiques
.TP 
\fB\-D\fR
Inclut les lignes sources pour le dbogage 
.TP 
\fB\-F\fR
Dclare l'entre comme du format standard (colonnage fixe)
.TP 
\fB\-I\fR <chemin> 
Dfinit le chemin de recherche des copy (dfaut \-I./)
Le chemin peut tre soit un seul rpertoire, soit une liste
de rpertoires spars par un `:' (`;' sur la plateforme Win32).
.TP 
\fB\-P\fR
Gnre un fichier liste
.TP 
\fB\-T\fR <nombre>
Transforme les tabulations en <nombre> d'espaces (dfaut T=8)
.TP 
\fB\-X\fR
Dclare l'entre comme du format libre X/Open (format par dfaut)
.PP 
.SH "FICHIERS"
.TP
.I htcobolrc\fR fichier de ressources d'options.
.SH ENVIRONNEMENT
.TP
.B TCOB_OPTIONS
.TP
Nom du fichier de ressources d'options.
.TP
Le nom par dfaut est
.I htcobolrc\fR.
.TP
.B TCOB_OPTIONS_PATH
Rpertoire du fichier de ressources d'options.
.TP
.B TCOB_PP_PATH
Rpertoire du prprocesseur.
.TP
.B TCOB_LD_LIBRARY_PATH
Chemin de recherche des librairies charges dynamiquement.
.TP
.B  TEMP
Rpertoire pour les fichiers temporaires.
.SH "VOIR AUSSI"
GCC(1), as(1), ld(1), make(1).
