.\"
.\"  Created by Ferran Pegueroles using help2man and modified by hand.
.\"  Modified and updated by David Essex.
.\" 
.TH HTCOBOL 1 "24 giugno 2002"
.UC 6
.SH NOME
htcobol \- compilatore COBOL 85
.SH SINTASSI
.B htcobol 
[
.I opzioni
] 
.I nome_file
.SH "DESCRIZIONE"
Un compilatore per il 
\fBCO\fRmmon
\fBB\fRusiness 
\fBO\fRriented 
\fBL\fRanguage, 
\fBCOBOL\fR.
.PP 
.I Htcobol
legge il sorgente COBOL dal file
.I nome_file
e, in funzione delle opzioni, preprocessa, compila, assembla e linka
generando un file binario eseguibile.
.PP
Il compilatore genera GNU assembler per la piattaforma IA32 (i386).
Con l'ausilio degli strumenti \fBGCC\fR,
questo codice intermedio puo` essere assemblato e linkato producendo un file binario eseguibile.  
.PP
Il file binario eseguibile puo` essere prodotto direttamente dal compilatore, oppure puo` essere generato un codice assembler intermedio ed usare poi la procedura 
.I Makefile
per le fasi di assemblaggio e di link.
.PP
Il compilatore riconosce divere opzioni nella linea di comando, come descritto di seguito.
.PP
E` possibile ottenere un testo d'aiuto eseguendo htcobol con l'opzione
.B \-h.
.PP
.SH "FILES D'INIZIALIZZAZIONE"
Svariate opzioni per il compilatore possono essere configurate nella linea di comando e/o utilizzando il file delle opzioni.
.PP
Il nome di default del file delle opzioni e`
.I htcobolrc\fR.
.PP
La precedenza di ogni opzione di compilazione e` descritta di seguito:
.TP
1.
Opzione su linea di comando, se disponibile.
.TP
2.
Variabile d'ambiente, se disponibile.
.TP
3.
Il file delle opzioni, se disponibile.
.TP
4.
Opzioni di compilazione di default, se definite.
.SH "OPZIONI"
.B Opzioni specifice del Compilatore:
.TP
\fB\-h\fR 
Visualizza l'aiuto.
.TP 
\fB\-a\fR
Crea libreria statica; Preprocessa, compila, assembla e comprime
.TP 
\fB\-B\fR
mode Specifica la modalita` di collegamento (statica/dinamica)
.TP 
\fB\-c\fR
Compila generando un modulo oggetto linkato staticamente
.TP 
\fB\-E\fR
Invoca il preprocessore inviando il risultato nello 'standard output'; non compila, ne` assembla o linka.
.TP 
\fB\-g\fR
Genera un file utilizzabile per il debugging
.TP 
\fB\-l\fR <nome> 
Aggiungi la libreria 'nome' nella fase di link
.TP 
\fB\-L\fR <dir> 
Aggiungi la cartella 'dir' nel percorso di ricerca delle librerie
.TP 
\fB\-m\fR 
Crea una libreria d'uso comune (shared); preprocessa, compila, assembla e linka
.TP 
\fB\-n\fR
Non esegue alcun comando; visualizza solo cio` che farebbe
.TP 
\fB\-o\fR <file> 
Specifica il file da genereare
.TP 
\fB\-S\fR
Preprocessa, compila (genera codice assembler) solo; non assembla o linka
.TP 
\fB\-t\fR
Non rimuove i files intermedi (assembly file, COBOL file da pre-processo) generati
durante la compilazione.
.TP 
\fB\-v\fR
Genera messaggi estesi durante la compilazione
.TP 
\fB\-V\fR
Visualizza la versione del compilatore and esce
.TP 
\fB\-Wl,<options> \fR 
Passa <opzioni> (separate da virgola) al linker
.TP 
\fB\-x\fR
Genera un modulo eseguibile
.TP 
\fB\-z\fR
Genera messaggi molto estesi durante la compilazione
.PP 
.B opzioni specifiche COBOL:
.TP 
\fB\-C\fR
Rendi tutte le 'calls' COBOL dinamiche
.TP 
\fB\-D\fR
Includi le linee di sorgente per il debugging
.TP 
\fB\-F\fR
Il sorgente in ingresso e` formattato in modalita` standard (fixed column)
.TP 
\fB\-I\fR <path> 
Definisce le cartelle 'path' di ricerca delle 'include' (copybooks) (default \-I./)
Il percorso puo` essere sia una singola cartella, sia un elenco di
cartelle separate da ":" (";" su piattaforma Win32).
.TP 
\fB\-P\fR
Genera un listato di compilazione
.TP 
\fB\-T\fR <num>
Converti i 'tabs' in 'num' spazi (default T=8)
.TP 
\fB\-X\fR
Il sorgente in ingresso ha la formattazione libera (X/Open free format) (default format)
.PP 
.SH "FILES"
.TP
.I htcobolrc\fR file risorse delle opzioni.
.SH VARIABILI D'AMBIENTE
.TP
.B TCOB_OPTIONS
Nome del file risorse delle opzioni.
Il nome di default e`
.I htcobolrc\fR.
.TP
.B TCOB_OPTIONS_PATH
Percorso della cartella contenente il file delle opzioni.
.TP
.B TCOB_PP_PATH
Percorsso della cartella contenente il preprocessore.
.TP
.B TCOB_LD_LIBRARY_PATH
Percorso di ricerca delle librerie caricate dinamicamente.
.TP
.B  TEMP
Percorso della cartella dei files temporanei.
.SH "VEDI ANCHE"
GCC(1), as(1), ld(1), make(1).


.SH "Traduzione"
Eseguita da Mario Lodi Rizzini (mlodirizzini@libero.it).

