.\"
.\"  Created by Ferran Pegueroles using help2man and modified by hand.
.\"  Modified and updated by David Essex.
.\"  Translated to portuguese language by Hudson Reis.
.\" 
.TH HTCOBOL 1 "22 de Janeiro de 2002"
.UC 6
.SH NOME
htcobol \- compilador COBOL 85
.SH SUMARIO
.B htcobol 
[
.I opcoes
] 
.I nomedoarquivo
.SH "DESCRICAO"
Um compilador para a  
\fBCO\fRmmon
\fBB\fRusiness 
\fBO\fRriented 
\fBL\fRanguage, 
\fBCOBOL\fR.
.PP 
.I Htcobol
le o fonte COBOL no arquivo
.I nomedoarquivo
e dependendo da opcao ele ira preprocessar, compilar, assemblar e linkar
gerando um binario executavel.
.PP
O compilador gera GNU assembler para a plataforma IA32 (i386).
Com a ajuda do conjunto de ferramentas \fBGCC\fR, este codigo intermediario
pode ser compilado e linkado gerando um binario executavel.
.PP
Um binario executavel pode ser criado diretamente pelo compilador, ou 
gerar o codigo assembler intermediario usando um 
.I Makefile
para os passos de assemble e link.
.PP
O compilador reconhece varias opcoes de linha de comando como descrito abaixo.
.PP
Voce pode obter uma mensagem de help invocando htcobol com a opcao
.B \-h
.PP
.SH "ARQUIVOS DE INICIALIZACAO"
Muitas opcoes do compilador podem ser setadas 
usando o arquivo de recursos e/ou opcoes na 
linha de comando.
.PP
O nome do arquivo de recursos padrao e
.I htcobolrc\fR.
.PP
A precedencia de algumas opcoes do compilador sao a seguir:
.TP
1.
Opcoes de linha de comando, se disponiveis.
.TP
2.
Variaveis de ambiente, se disponiveis.
.TP
3.
Opoes de arquivo de recursos, se disponivel.
.TP
4.
Opcoes padrao de recurso em tempo de compilacao, se disponiveis.
.SH "OPCOES"
.B Opcoes especificas do Compilador:
.TP
\fB\-h\fR 
Mostra ajuda.
.TP 
\fB\-a\fR
Cria biblioteca estatica; pre-processa, compila, assembla e arquiva.
.TP 
\fB\-B\fR
modo especifico para aglutinacao (estatica/dinamica).
.TP 
\fB\-c\fR
Compilacao para um modulo de objeto estaticamente linkado.
.TP 
\fB\-E\fR
Saida do preprocessador para saida padrao apenas; nao compila, assembla ou linka.
.TP 
\fB\-g\fR
Gera saida de debug de compilacao.
.TP 
\fB\-l\fR <arquivo> 
Adiciona biblioteca na linkedicao.
.TP 
\fB\-L\fR <diretorio> 
Adiciona diretorio ao caminho de procura de bibliotecas.
.TP 
\fB\-m\fR
Cria biblioteca compartilhada; pre-processa, compila, assembla e linka.
.TP 
\fB\-n\fR 
Nao executa nenhum comando, deve mostrar a compilacao.
.TP 
\fB\-o\fR
Especifica o nome do arquivo de saida.
.TP 
\fB\-S\fR
Preprocessa, compila(gera codigo assembler) somente; nao assembla ou linka.
.TP 
\fB\-t\fR
Nao remove os arquivos intermediarios(arquivo assembly, arquivo COBOL pre-processado)
gerados durante a compilacao.
.TP 
\fB\-v\fR
Gera saida do compilador verbosa.
.TP 
\fB\-V\fR
Mostra informacoes da versao do compilador e sai.
.TP 
\fB\-Wl,<opcoes>\fR
Passar opcoes separadas por virgula ao linkeditor.
.TP 
\fB\-x\fR
Compilacao para criar um executavel.
.TP 
\fB\-z\fR
Gera saida do compilador muito extensa.
.PP 
.B Opcoes especificas do COBOL:
.TP 
\fB\-C\fR
Faz todas as chamadas dinamicas COBOL.
.TP 
\fB\-D\fR
Inclui linhas de debug no fonte.
.TP 
\fB\-F\fR
Fonte de entrada esta em formato de coluna fixa padrao.
.TP 
\fB\-I\fR <path> 
Define inclusao(copybooks) de caminhos de procura. (padrao \-I./)
O caminho pode ser um simples diretorio, ou uma lista de 
diretorios separados por um ':'.(';' em plataforma Win32).
.TP 
\fB\-P\fR
Gera arquivo de saida listado.
.TP 
\fB\-T\fR <num>
Expande tabs para um numero de espacos (padrao T=8).
.TP 
\fB\-X\fR
Arquivo de entrada esta em formato livre X/Open (formato padrao).
.PP 
.SH "ARQUIVOS"
.TP
.I htcobolrc\fR arquivo de opcoes de recurso.
.SH AMBIENTE
.TP
.B TCOB_OPTIONS
.TP
Nome do arquivo de opcoes de recurso.
.TP
Nome padrao e
.I htcobolrc\fR.
.TP
.B TCOB_OPTIONS_PATH
Caminho de diretorio do arquivo de opcoes.
.TP
.B TCOB_PP_PATH
Caminho do diretorio do preprocessador.
.TP
.B TCOB_LD_LIBRARY_PATH
Caminho do diretorio das bibliotecas carregadas dinamicamente.
.TP
.B  TEMP
Caminho do diretorio dos arquivos temporarios.

.SH "VEJA TAMBEM"
GCC(1), as(1), ld(1), make(1).
