..\"
.\"  Created by David Essex.
.\" 
.TH HTCOBOLPP 1 "January 22, 2002"
.UC 6
..SH "NAME"
htcobolpp \- COBOL pre-processor
.SH SYNOPSIS
.B htcobolpp 
[
.I options=hVvdtpxfI
] 
input-filename
[ -o
.I output-filename
] 
.SH "DESCRIPTION"
The COBOL pre-processor program will perform the following functions:
.TP
1.
Convert COBOL source from fixed to free\-form format.
.TP
2.
Process the \fBCOPY/REPLACING\fR statements found in the COBOL sources. 
.TP
3.
Process the \fBREPLACE\fR statements found in the COBOL sources
(not currently implimented). 
.TP
4.
Print COBOL source listings. 
.PP
The default output stream is standard output.
.PP
Note this version will not automatically convert all tabs to white space. 
.PP
The 
.B expand 
conversion utility is better suited to perform this task.

.SH "OPTIONS"
.TP
\fB\-h\fR
Display help.
.TP
\fB\-d\fR
Include debug lines.
.TP
\fB\-f\fR <input_file>
Input source is in standard fixed column format.
.TP
\fB\-g\fR
Turn on debuging mode.
.TP
\fB\-I\fR <copy_dir>
Copybooks search directories.
.TP
\fB\-p\fR <listing_file>
Listing file name.
.TP
\fB\-o\fR <output_file>
Output file name (default: standard output).
.TP
\fB\-t\fR <num> 
Expand tabs to <num> space(s).
.TP
\fB\-x\fR <input_file>
Input source is in free form format.
.TP 
\fB\-V\fR
Print version.
.TP 
\fB\-v\fR
Verbose mode.

.SH "SEE ALSO"
htcobol(1), htcobf2f(1), expand(1)
