CREATE TABLE "produto" ("prodid" "int4" NOT NULL, "pnome" char(50), "codbarras" char(13), "unidid" "int4", "classifid" "int4", "estoque" "int4", "ppreco" char(11), "fornid" "int4");
CREATE TABLE "fornecedor" ("fornid" "int4" NOT NULL, "fnome" char(50), "fendereco" char(50), "finscricao" char(20), "fcgc" char(20), "ffone" char(20));
CREATE TABLE "entrada" ("entrid" "int4" NOT NULL, "prodid" "int4", "equant" "int4", "edata" "date", "funcid" "int4", "custo" char(11), "nf" char(20));
CREATE TABLE "venda" ("vendid" "int4" NOT NULL, "funcid" "int4", "total" char(11), "pgtoid" "int4", "vdata" "date");
CREATE TABLE "pagamento" ("pgtoid" "int4" NOT NULL, "pnome" char(50), "comissao" "int4", "acresc" "int4", "desconto" "int4", "baixa" char(1));
CREATE TABLE "unidade" ("unidid" "int4" NOT NULL, "udescricao" char(50));
CREATE TABLE "classif" ("classifid" "int4" NOT NULL, "cdescricao" char(50));
CREATE TABLE "item" ("itemid" "int4" NOT NULL, "vendid" "int4", "prodid" "int4", "iquant" "int4", "ipreco" char(11), "idesconto" "int4");
CREATE TABLE "funcionario" ("funcid" "int4" NOT NULL, "vnome" char(50), "saldo" char(11), "vcomissao" char(4));
INSERT INTO "produto" values (5,'Adaptador DB25 / DB9 Serial RS-232                ',NULL,1,1,120,'800        ',2);
INSERT INTO "produto" values (6,'Suporte para fita adesiva 3M                      ',NULL,1,3,15,'1200       ',4);
INSERT INTO "produto" values (10,'Suporte para canetas                              ',NULL,1,3,26,'320        ',3);
INSERT INTO "produto" values (11,'Impressora jato de tinta HP680                    ',NULL,1,3,8,'38000      ',4);
INSERT INTO "produto" values (12,'Perfurador de papel 3 furos                       ',NULL,1,3,21,'4600       ',2);
INSERT INTO "produto" values (2,'Mostarda 200 g.                                   ',NULL,1,2,100,'120        ',1);
INSERT INTO "produto" values (3,'Computador IBM-PC                                 ',NULL,1,3,12,'98000      ',2);
INSERT INTO "produto" values (243,'Terreno em Aldeia (loteamento)                    ',NULL,1,1,1,'2345720    ',1);
INSERT INTO "produto" values (5567,'Calculador Casio HL-812                           ',NULL,1,3,200,'230        ',3);
INSERT INTO "produto" values (1,'Coca-cola                                         ','7891234567123',1,2,500,'165        ',3);
INSERT INTO "produto" values (4,'Control remoto infravermelho                      ',NULL,1,1,5,'3515       ',1);
INSERT INTO "produto" values (4545,'Caixa de Som amplificada  Dynacom                 ',NULL,NULL,NULL,5,'2222       ',2);
INSERT INTO "produto" values (1234,'TurboLinux 2.0                                    ',NULL,1,3,504,'4950       ',1);
INSERT INTO "produto" values (8,'Terminal KeenView multiponto para Unix/Linux      ',NULL,1,3,37,'17000      ',3);
INSERT INTO "produto" values (5678,'Manual do Usuario PostgreSQL                      ',NULL,NULL,NULL,11,'2315       ',1);
INSERT INTO "produto" values (9,'Relgio digital Casio Data Bank                   ',NULL,1,1,7,'6500       ',2);
INSERT INTO "produto" values (8756,'Grampeador                                        ','             ',1,3,37,'325        ',4);
INSERT INTO "produto" values (546576,'PICStart Plus development programmer              ','7651234567890',1,2,2,'19900      ',4);
INSERT INTO "produto" values (7,'teste                                             ','             ',0,0,0,'           ',0);
INSERT INTO "fornecedor" values (2,'Volkswagen                                        ','                                                  ','                    ','                    ','                    ');
INSERT INTO "fornecedor" values (3,'Computer One Ltda                                 ','                                                  ','                    ','                    ','                    ');
INSERT INTO "fornecedor" values (4,'Bompreo                                          ','                                                  ','                    ','                    ','                    ');
INSERT INTO "fornecedor" values (1,'Nestle                                            ','                                                  ','                    ','                    ','                    ');
INSERT INTO "fornecedor" values (7,'Goodyear do Brasil Ltda                           ','So Paulo                                         ','                    ','                    ','                    ');
INSERT INTO "fornecedor" values (12,'Pragana, Filhos & Cia Ltda                        ','Estr.  de Aldeia, Km.11                           ','                    ','                    ','                    ');
INSERT INTO "venda" values (1,1,'123.45     ',1,'11-07-1999');
INSERT INTO "unidade" values (1,'PEA                                              ');
INSERT INTO "unidade" values (2,'QUILOGRAMA                                        ');
INSERT INTO "unidade" values (3,'Litro                                             ');
INSERT INTO "unidade" values (4,'Duzia                                             ');
INSERT INTO "classif" values (1,'produtos diversos                                 ');
INSERT INTO "classif" values (2,'Alimentos                                         ');
INSERT INTO "classif" values (3,'Material de Escritrio                            ');
INSERT INTO "item" values (1,1,5,2,'56.20      ',0);
INSERT INTO "item" values (2,1,12,1,'1.30       ',0);
CREATE UNIQUE INDEX "prodidx" on "produto" using btree ( "prodid" "int4_ops" );
CREATE UNIQUE INDEX "fornidx" on "fornecedor" using btree ( "fornid" "int4_ops" );
CREATE UNIQUE INDEX "entridx" on "entrada" using btree ( "entrid" "int4_ops" );
CREATE UNIQUE INDEX "vendidx" on "venda" using btree ( "vendid" "int4_ops" );
CREATE UNIQUE INDEX "pgtoidx" on "pagamento" using btree ( "pgtoid" "int4_ops" );
CREATE UNIQUE INDEX "unididx" on "unidade" using btree ( "unidid" "int4_ops" );
CREATE UNIQUE INDEX "classifidx" on "classif" using btree ( "classifid" "int4_ops" );
CREATE UNIQUE INDEX "itemidx" on "item" using btree ( "itemid" "int4_ops" );
CREATE UNIQUE INDEX "funcidx" on "funcionario" using btree ( "funcid" "int4_ops" );
