 IDENTIFICATION DIVISION.
 PROGRAM-ID. TEST3-FORMATS.
 AUTHOR.  GLEN COLBERT.

 ENVIRONMENT DIVISION.
* INPUT-OUTPUT SECTION.
* FILE-CONTROL.
 DATA DIVISION.
 FILE SECTION.

 WORKING-STORAGE SECTION.
 01  WS-EDITED-FIELDS.
     05 WS-AB-5                      PIC XXBXXX.
     05 WS-AB-3                      PIC XBXX.
     05 WS-AS-5                      PIC XX/XXX.
     05 WS-AS-3                      PIC X/XX.

 01  WS-NUMERIC-FIELDS.
     05 WS-DISPLAY-NUM-1             PIC 9.
     05 WS-DISPLAY-NUM-2             PIC 9(2).
     05 WS-DISPLAY-NUM-3             PIC 9(3).
     05 WS-DISPLAY-NUM-4             PIC 9(4).
     05 WS-DISPLAY-NUM-5             PIC 9(5).
     05 WS-DISPLAY-NUM-6             PIC 9(6).
     05 WS-DISPLAY-NUM-7             PIC 9(7).
     05 WS-DISPLAY-NUM-V5            PIC 9(3)V99.
     05 WS-DISPLAY-NUM-R5 REDEFINES WS-DISPLAY-NUM-V5
                                     PIC X(5).

 PROCEDURE DIVISION.
 0000-PROGRAM-ENTRY-POINT.
     DISPLAY "TEST03 FORMATS program entry."

     PERFORM A000-ALPHANUMERIC-TESTS THRU A000-EXIT.

     STOP RUN.

 A000-ALPHANUMERIC-TESTS.

 AN01-TEST.
     MOVE 9                   TO WS-DISPLAY-NUM-1.
     MOVE 89                  TO WS-DISPLAY-NUM-2.
     MOVE 789                 TO WS-DISPLAY-NUM-3.
     MOVE 6789                TO WS-DISPLAY-NUM-4.
     MOVE 56789               TO WS-DISPLAY-NUM-5.
     MOVE 456789              TO WS-DISPLAY-NUM-6.
     MOVE 3456789             TO WS-DISPLAY-NUM-7.

     MOVE WS-DISPLAY-NUM-1    TO WS-AB-5.
     DISPLAY "AE01:(" WS-AB-5 "):(9     ):"
             "ALIGNMENT/BLANKS MOVE TEST MOVE 9(1) TO XXBXXX".

     MOVE WS-DISPLAY-NUM-3    TO WS-AB-5.
     DISPLAY "AE02:(" WS-AB-5 "):(78 9  ):"
             "ALIGNMENT/BLANKS MOVE TEST MOVE 9(3) TO XXBXXX".

     MOVE WS-DISPLAY-NUM-5    TO WS-AB-5.
     DISPLAY "AE03:(" WS-AB-5 "):(56 789):"
             "ALIGNMENT/BLANKS MOVE TEST MOVE 9(5) TO XXBXXX".

     MOVE WS-DISPLAY-NUM-7    TO WS-AB-5.
     DISPLAY "AE04:(" WS-AB-5 "):(34 567):"
             "ALIGNMENT/BLANKS MOVE TEST MOVE 9(7) TO XXBXXX".

     MOVE WS-DISPLAY-NUM-1    TO WS-AB-3.
     DISPLAY "AE05:(" WS-AB-3 "):(9   ):"
             "ALIGNMENT/BLANKS MOVE TEST MOVE 9(1) TO XBXX".

     MOVE WS-DISPLAY-NUM-3    TO WS-AB-3.
     DISPLAY "AE06:(" WS-AB-3 "):(7 89):"
             "ALIGNMENT/BLANKS MOVE TEST MOVE 9(3) TO XBXX".

     MOVE WS-DISPLAY-NUM-5    TO WS-AB-3.
     DISPLAY "AE07:(" WS-AB-3 "):(5 67):"
             "ALIGNMENT/BLANKS MOVE TEST MOVE 9(5) TO XBXX".

     MOVE WS-DISPLAY-NUM-7    TO WS-AB-3.
     DISPLAY "AE08:(" WS-AB-3 "):(3 45):"
             "ALIGNMENT/BLANKS MOVE TEST MOVE 9(7) TO XBXX".

     MOVE WS-DISPLAY-NUM-1    TO WS-AS-5.
     DISPLAY "AS01:(" WS-AS-5 "):(9 /   ):"
             "ALIGNMENT/BLANKS MOVE TEST MOVE 9(1) TO XX/XXX".

     MOVE WS-DISPLAY-NUM-3    TO WS-AS-5.
     DISPLAY "AS02:(" WS-AS-5 "):(78/9  ):"
             "ALIGNMENT/BLANKS MOVE TEST MOVE 9(3) TO XX/XXX".

     MOVE WS-DISPLAY-NUM-5    TO WS-AS-5.
     DISPLAY "AS03:(" WS-AS-5 "):(56/789):"
             "ALIGNMENT/BLANKS MOVE TEST MOVE 9(5) TO XX/XXX".

     MOVE WS-DISPLAY-NUM-7    TO WS-AS-5.
     DISPLAY "AS04:(" WS-AS-5 "):(34/567):"
             "ALIGNMENT/BLANKS MOVE TEST MOVE 9(7) TO XX/XXX".

     MOVE WS-DISPLAY-NUM-1    TO WS-AS-3.
     DISPLAY "AS05:(" WS-AS-3 "):(9/  ):"
             "ALIGNMENT/BLANKS MOVE TEST MOVE 9(1) TO X/XX".

     MOVE WS-DISPLAY-NUM-3    TO WS-AS-3.
     DISPLAY "AS06:(" WS-AS-3 "):(7/89):"
             "ALIGNMENT/BLANKS MOVE TEST MOVE 9(3) TO X/XX".

     MOVE WS-DISPLAY-NUM-5    TO WS-AS-3.
     DISPLAY "AS07:(" WS-AS-3 "):(5/67):"
             "ALIGNMENT/BLANKS MOVE TEST MOVE 9(5) TO X/XX".

     MOVE WS-DISPLAY-NUM-7    TO WS-AS-3.
     DISPLAY "AS08:(" WS-AS-3 "):(3/45):"
             "ALIGNMENT/BLANKS MOVE TEST MOVE 9(5) TO X/XX".

 A000-EXIT.
     EXIT.
