#
# Makefile to create binary form COBOL sources
#

prefix=/usr/local/
comp_prefix=../../..
exec_prefix=${comp_prefix}/compiler
g_includes=-I/usr/local/include
g_libraries=-L/usr/lib

CCX=gcc
COBPP=${comp_prefix}/cobpp/htcobolpp
COB=${exec_prefix}/htcobol
ASM=as
RM=rm -f

COPYBOOKS= -I../copybooks -I.
INCLUDES=-I./ ${g_includes} 
LIBS=${g_libraries} -L${comp_prefix}/lib -lhtcobol -ldb -lm -ldl
LDFLAGS=
COBFLAGS=-P ${COPYBOOKS}
ASMFLAGS=-D
CCXFLAGS=-g ${INCLUDES}

%.cob : %.CBL
	${COBPP} ${COPYBOOKS} -f $< -o $@
%.s : %.cob
	${COB} -T8 -S -P -D $*.cob
	grep "error" $*.lis
%.o : %.s
	${ASM} -o $*.o -as=$*.listing.0.txt --gstabs $*.s
%.EXE : %.o
	gcc -g -o $*.EXE $*.o ${LIBS}
%.PRT : %.EXE
	./$*.EXE 2>nl
	mv -f nl $*.RTE
	mv prt $*.PRT
	${RM} $*.cob $*.lis* $*.o $*.s $*.scan $*.EXE
