 IDENTIFICATION DIVISION.
 PROGRAM-ID.    SEQIO02.
 ENVIRONMENT DIVISION.

 CONFIGURATION SECTION. 
 SPECIAL-NAMES.
     DECIMAL-POINT IS COMMA.
 INPUT-OUTPUT SECTION.
 FILE-CONTROL.
     SELECT GOZOUT ASSIGN TO "./nofile.dat" 
            ORGANIZATION IS SEQUENTIAL 
            ACCESS MODE  IS SEQUENTIAL
            FILE STATUS  IS FS.

 DATA DIVISION.
 FILE SECTION.

 FD  GOZOUT
     LABEL RECORD IS STANDARD.
 01  GOZOUT-REC.
     03 X-IND                         PIC  9(03).
     03 DESCRIPTION                   PIC  X(20).
     03 FILLER                        PIC  X(57).
      
 WORKING-STORAGE SECTION.
 01  FS                              PIC  9(02).

 PROCEDURE DIVISION.
 0000-PROGRAM-ENTRY.

      PERFORM C000-MAIN-LOGIC THRU C000-EXIT.
      PERFORM D000-CLEANUP THRU D000-EXIT.
      STOP RUN.

 B000-INITIALIZE.
      OPEN OUTPUT GOZOUT.
      DISPLAY "SA01:(" FS "):(00):"
          "SEQUENTIAL I/O OPEN STATUS".

 B000-EXIT.
      EXIT.

 C000-MAIN-LOGIC.
      MOVE SPACES TO GOZOUT-REC.
      MOVE 001 TO X-IND.
      MOVE "FIRST RECORD" TO DESCRIPTION.
      WRITE GOZOUT-REC.
      DISPLAY "SA02:(" FS "):(48):"
          "SEQUENTIAL I/O WRITE STATUS".

 C000-EXIT.
      EXIT.

 D000-CLEANUP.
      CLOSE GOZOUT.
      DISPLAY "SA03:(" FS "):(42):"
          "SEQUENTIAL I/O CLOSE STATUS".

 D000-EXIT.
      EXIT.
