 IDENTIFICATION DIVISION.
 PROGRAM-ID.    SEQIO04.
 ENVIRONMENT DIVISION.
* THIS FILE IS SUPPOSED TO READ PAST EOF

 CONFIGURATION SECTION. 
 SPECIAL-NAMES.
     DECIMAL-POINT IS COMMA.
 INPUT-OUTPUT SECTION.
 FILE-CONTROL.
     SELECT GOZIN ASSIGN TO "./input.dat" 
            ORGANIZATION IS SEQUENTIAL 
            ACCESS       IS SEQUENTIAL
            FILE STATUS  IS FS.

 DATA DIVISION.
 FILE SECTION.

 FD  GOZIN
     LABEL RECORD IS STANDARD.
 01  GOZIN-REC.
     03 X-IND                         PIC  9(03).
     03 DESCRIPTION                   PIC  X(20).
     03 FILLER                        PIC  X(57).
      
 WORKING-STORAGE SECTION.
 01  FS                              PIC  9(02).

 PROCEDURE DIVISION.
 0000-PROGRAM-ENTRY.
      PERFORM B000-INITIALIZE THRU B000-EXIT.
      PERFORM C000-MAIN-LOGIC THRU C000-EXIT.
      PERFORM D000-CLEANUP THRU D000-EXIT.
      STOP RUN.

 B000-INITIALIZE.
      OPEN INPUT GOZIN.
      DISPLAY "SQ01:(" FS "):(00):"
          "SEQUENTIAL I/O OPEN STATUS".
 B000-EXIT.
     EXIT.

 C000-MAIN-LOGIC.
      READ GOZIN.
      DISPLAY "SR02:(" FS "):(00):"
          "SEQUENTIAL I/O READ STATUS".
      DISPLAY "SR03:(" DESCRIPTION "):(FIRST RECORD        ):"
          "DATA FROM READ".

      READ GOZIN.
      READ GOZIN.
      READ GOZIN.
      DISPLAY "SR14:(" FS "):(10):"
          "SEQUENTIAL I/O READ STATUS PAST EOF".
 C000-EXIT.
      EXIT.

 D000-CLEANUP.
      CLOSE GOZIN.
      DISPLAY "SR15:(" FS "):(00):"
          "SEQUENTIAL I/O CLOSE STATUS".

 D000-EXIT.
     EXIT.  
